/*
Si consideri la seguente definizione di un albero:
	typedef struct EL { int dato;
	                    struct EL * left, * right;} Node;
	typedef node * Tree;
Si definisce livello di un nodo la sua distanza dalla radice.
Si scriva una funzione che prende in ingresso un albero binario e restituisce
- 1 se tutti i nodi di livello pari contengono un numero pari e tutti i nodi di livello dispari contengono un numero dispari.
- 0 altrimenti
*/

#include<stdio.h>
#include<stdlib.h>

typedef struct el
{
    int v;
    struct el *left;
    struct el * right;
} Nodo;
typedef Nodo * Tree;

Tree insert(Tree t, int x);
void print(Tree);
void stampa(Tree);
int alternato_wrap(Tree);
int alternato(Tree, int);

int main()
{
    Tree t=NULL;

    t=insert(t,12);
    t=insert(t,1);
    t=insert(t,21);
    t=insert(t,22);
    t=insert(t,16);

    stampa(t);
    printf("\n alberto alternato:%d", alternato_wrap(t));
    return 0;
}

int alternato_wrap(Tree t)
{
    return alternato(t, 0);
}

int alternato(Tree t, int l)
{

    //casi base
    if(t == NULL)
        return  1;

    if(l%2 != t->v%2)
        return 0;

    // passo induttivo
    return (alternato(t->left, l+1) * alternato(t->right, l+1));
}




Tree insert(Tree t, int x)
{
    Tree tmp;

    if(t==NULL)
    {
        tmp=(Tree)malloc(sizeof(Nodo));
        tmp->v=x;
        tmp->left=NULL;
        tmp->right=NULL;
        return tmp;
    }

    if(x < t->v)
    {
        t->left=insert(t->left,x);
    }
    else if(x > t->v)
    {
        t->right=insert(t->right,x);
    }

    return t;
}

void print(Tree t)
{
    if(t==NULL)
        return;
    else
    {
        printf(" (");
        print(t->left);
        printf(" %d ",t->v);
        print(t->right);
        printf(") ");
    }
}
void stampa(Tree t)
{
    print(t);
    printf("\n");
}


