#include<stdio.h>
#include<string.h>
#define N 100
/*
Si scriva un programma che indirizza le seguente richieste
- Apre il file votiInfoA.txt e copia nel file votiAlti.txt tutti gli studenti che hanno preso un voto
maggiore a 18
- Senza caricare in memoria i nomi ed i voti di tutti gli studenti, si calcoli il voto medio ed il
nome di uno studente che ha preso il voto pi vicino al voto medio (nel caso fossero pi di
uno  indifferente quale viene restituito)
- Carica tutti i dati in una listaStudenti opportunamente definita e calcola il voto mediano
- Definisce un secondo tipo: listaVoti i cui nodi sono ordinati e contengono ciascuno un voto e
una lista di tutti gli studenti che hanno preso quel voto
- Si scriva la funzione stampa (su file) del contentuto della lista dei voti
*/

typedef char Stringa[N];

typedef struct El
{
    Stringa nome;
    int voto;
    struct El* next;
} Studente;

typedef Studente *ListaStudenti;

typedef struct El2
{
    int voto;
    ListaStudenti studenti;
    struct El2* next;
} Voti;

typedef Voti* ListaVoti;

float differenzaAssoluta(float a, float b);
ListaStudenti insInTesta(ListaStudenti l, char s[], int n);
ListaVoti insTestaVoti(ListaVoti v, char s[], int voto);
ListaVoti esiste(ListaVoti v, int voto);

void stampaLista(ListaStudenti l);
void stampaListaVoti(ListaVoti l);
void stampaListaFile(ListaStudenti l, FILE* p);
void stampaListaVotiFile(ListaVoti l, FILE* p);

int main()
{
    Stringa nome, studMedio;
    int voto,s=0,n=0, votoMedio;
    FILE *p,*q;
    float media, dist = 30, temp;
    ListaStudenti l = NULL;
    ListaVoti v = NULL;

    // apre i files
    p = fopen("votiInfoA.txt", "r");
    q = fopen("votiAlti.txt", "w");

    if(p!= NULL && q!= NULL)
    {
        while(!feof(p)) // feof(p) restituisce 0 (falso) se p NON  alla fine del file
        {
            fscanf(p, "%s %d", nome, &voto);
            n++;
            s+=voto;
            if(voto > 25)
                fprintf(q, "%s %d\n", nome, voto);

            l = insInTesta(l, nome, voto);
            v = insTestaVoti(v, nome, voto);
        }

        stampaLista(l);
        stampaListaFile(l, q);
        stampaListaVoti(v);

        stampaListaVotiFile(v, q);

        media = (float) s / n;
        printf("\n voto medio: %.2f", media);

        fclose(p);
        fclose(q);

        //cerchiamo "lo studente medio"
        p = fopen("votiInfoA.txt", "r");
        while(!feof(p)) // feof(p) restituisce 0 (falso) se p NON  alla fine del file
        {
            fscanf(p, "%s %d", nome, &voto);
            temp = differenzaAssoluta((float)voto, media);
            if(temp <= dist)
            {
                //printf("\n Studente Medio: %s voto: %d", nome, voto);
                strcpy(studMedio, nome);
                votoMedio = voto;
                dist = temp;
            }
        }
        printf("\n Studente Medio: %s voto: %d", studMedio, votoMedio);
    }
    else
    {
        printf("Files non accessibili!");
    }

    return 0;
}

float differenzaAssoluta(float a, float b)
{
    if(a>b)
        return a-b;
    return b-a;
}

ListaStudenti insInTesta(ListaStudenti l, Stringa nome, int voto)
{
    ListaStudenti p;
    p = (Studente*) malloc(sizeof(Studente));
    p->voto = voto;
    p->next = l;
    strcpy(p->nome, nome);
    return p;
}

void stampaLista(ListaStudenti l)
{
    if(l == NULL)
        return;

    printf("%s (%d)  -->  ", l->nome, l->voto);
    stampaLista(l->next);
}


void stampaListaVoti(ListaVoti l)
{
    if(l == NULL)
        return;

    printf("\n[%d]\n ", l->voto);
    stampaLista(l->studenti);
    stampaListaVoti(l->next);
}

void stampaListaFile(ListaStudenti l, FILE* p)
{
    if(l == NULL)
        return;

    fprintf(p,"%s (%d)  -->  ", l->nome, l->voto);
    stampaListaFile(l->next, p);
}

void stampaListaVotiFile(ListaVoti l, FILE* p)
{
    if(l == NULL)
        return;

    fprintf(p, "\n[%d]\n ", l->voto);
    stampaListaFile(l->studenti, p);
    stampaListaVotiFile(l->next, p);
}


// cerca un nodo contenente il valore voto nella lista
ListaVoti esiste(ListaVoti v, int voto)
{
    if(v == NULL)
        return NULL;
    while(v != NULL)
    {
        if(v->voto == voto)
            return v;
        v = v->next;
    }
    return NULL;
}

// inserisci in maniera ordinata, evitando replicazioni ed aggiornando la lista degli studenti
// un nuovo studente nella lista dei voti
ListaVoti insTestaVoti(ListaVoti v, Stringa nome, int voto)
{
    ListaVoti temp, puntCorr = v, puntPrec = NULL;

    // controllo se il voto  gi stato inerito. In tal caso solo accodare lo studente alla sottolista
    temp = esiste(v, voto);
    if (temp!=NULL)
    {
        temp->studenti = insInTesta(temp->studenti, nome, voto);
        return v;
    }

    // devo creare un nuovo nodo

    // cerco dove inserire il voto come per fare un inserimento ordinato (ma so che non ci saranno replicati)
    while(puntCorr != NULL && puntCorr->voto < voto)
    {
        puntPrec = puntCorr;
        puntCorr = puntCorr->next;
    }

    // preparo il nuovo nodo
    temp = (ListaVoti) malloc(sizeof(Voti));
    temp->voto = voto;
    temp->studenti = NULL; //  importante inizializzare a NULL la sottolista, altrimenti non si chiude
    temp->studenti = insInTesta(temp->studenti, nome, voto); //importante inizializzare a NULL
    temp->next = puntCorr;

    // se era NULL puntPrec, allora lo era anche puntCurr
    if(puntPrec == NULL)
        return temp;
    else
        puntPrec->next = temp;

    return v;

}

